--KAMERA
-- M@D Author  xSenio
-- M@D date  15.11.2016

KAMERA = {};

function KAMERA.prerequisitesPresent(specializations)
    return true ;
end;

function KAMERA:load(savegame)

	self.anim = SpecializationUtil.callSpecializationsFunction("anim");
	self.Go = {}; 
	self.Done = {};
	self.charId = {};
	self.clipIndex = {};
	self.CheckDone = {};
	self.moveColli = {}; 
    self.animParts1 = {}
	self.collisionArm = {}; 
	local count = getXMLInt(self.xmlFile, "vehicle.animParts1#count");
	local part = self.animParts1;
    for i=1, count do
		part[i] = {};
        local partname = string.format("vehicle.animParts1.part".."%d", i);
	    local nameR = getXMLString(self.xmlFile, partname.."#name");
		self.charId[nameR] = Utils.indexToObject(self.components, getXMLString(self.xmlFile, partname.."#rootNode"));
		self.clipIndex[nameR] = getXMLString(self.xmlFile, partname.."#animationClip");
		self.CheckDone[nameR] = false;
	end;


end;

function KAMERA:delete()

end;

function KAMERA:mouseEvent(posX, posY, isDown, isUp, button)
end;

function KAMERA:keyEvent(unicode, sym, modifier, isDown)

	if isDown and sym==Input.KEY_KP_enter then
		self.Go.pillar = not self.Go.pillar; 
		self.Done.pillar = true;
	end;

end;

function KAMERA:update(dt)


	if self.Go.pillar ~= nil and self.Done.pillar ~= false then
		self:anim("pillar", false); 
	end; 

    if self.isEntered then

	self.input = InputBinding.getAnalogInputAxis(InputBinding.AXIS_MOVE_FORWARD_PLAYER);

	if InputBinding.isAxisZero(self.input) then
        	self.input = InputBinding.getDigitalInputAxis(InputBinding.AXIS_MOVE_FORWARD_PLAYER);
	end;

    end;

end;

function KAMERA:draw()

end;

function KAMERA:onEnter()

end;

function KAMERA:onLeave()


end;

function KAMERA:anim(varName, loopCheck)
	if self.moveColli[varName] ~= nil then
		local Collision = self.collisionArm[varName];
		setJointFrame(Collision.index, 0, Collision.armAttacher);
	end;
	if self.Go[varName] == true and self.Done[varName] ~= false then
		local charId = getAnimCharacterSet(self.charId[varName]);
		local clipIndex = getAnimClipIndex(charId, self.clipIndex[varName]);
		assignAnimTrackClip(charId , 0, clipIndex);
		setAnimTrackLoopState(charId, 0, loopCheck);
		setAnimTrackSpeedScale(charId, 0, 1);
		enableAnimTrack(charId, 0);
		if getAnimTrackTime(charId, 0) >= getAnimClipDuration(charId, clipIndex) and loopCheck == false then
			disableAnimTrack(charId, 0);	
			self.Done[varName] = false;	
			self.CheckDone[varName] = true;	
		end; 
	elseif self.Go[varName] == false and self.Done[varName] ~= false then
		local charId = getAnimCharacterSet(self.charId[varName]);
		local clipIndex = getAnimClipIndex(charId, self.clipIndex[varName]);
		if loopCheck == true then
			disableAnimTrack(charId, 0);
			self.Done[varName] = false;	
		end; 	
		assignAnimTrackClip(charId , 0, clipIndex);
		setAnimTrackLoopState(charId, 0, loopCheck);
		setAnimTrackSpeedScale(charId, 0, -1);
		enableAnimTrack(charId, 0);
		if getAnimTrackTime(charId, 0) <= 0 then
			disableAnimTrack(charId, 0);
			self.Done[varName] = false;	
			self.CheckDone[varName] = false;
		end;
	end;
end; 