--
-- Author: Karol Gruszczyk(MySQly)
--
-- version ID   - 1.0
-- version date - 12/0/2017
-- 
--

Pyskash = {}

function Pyskash.prerequisitesPresent(specializations)
    return true
end


function Pyskash:load(xmlFile)
    self.EF = {}
    self.EF.emittTime = 0
    
    self.EF.particleSystem = {}
    Utils.loadParticleSystem(self.xmlFile, self.EF.particleSystem, "vehicle.echaustParticleSystem", self.components, false, nil, self.baseDirectory)
    self.EF.psEmittTime = Utils.getNoNil(getXMLFloat(self.xmlFile, "vehicle.echaustParticleSystem#emittTime"), 1.0) * 1000
    self.EF.motorStartOffset = Utils.getNoNil(getXMLFloat(self.xmlFile, "vehicle.echaustParticleSystem#motorStartOffset"), 0.0) * 1000
end

function Pyskash:delete()
    Utils.deleteParticleSystem(self.EF.particleSystem)
end

function Pyskash:writeStream(streamId, connection)
end

function Pyskash:readStream(streamId, connection)
end

function Pyskash:mouseEvent(posX, posY, isDown, isUp, button)
end

function Pyskash:keyEvent(unicode, sym, modifier, isDown)
end

function Pyskash:update(dt)
end

function Pyskash:updateTick(dt)
    if self:getIsActive() then
        if self.EF.threshingEmitting then
            self.EF.emittTime = self.EF.emittTime + dt
        end
    end
    if self.isMotorStarted then
        if not self.EF.motorStartPlayed then
            self.EF.motorStartPlayed = true
            self.EF.motorEmitting = true
        end

        if self.EF.motorEmitting then
            self.EF.emittTime = self.EF.emittTime + dt
            if self.EF.emittTime > self.EF.motorStartOffset + self.EF.psEmittTime then
                self.EF.motorEmitting = false
            end

            local shouldEmitt = self.EF.emittTime > self.EF.motorStartOffset and self.EF.emittTime < self.EF.motorStartOffset + self.EF.psEmittTime
            Utils.setEmittingState(self.EF.particleSystem, shouldEmitt)
        end
    else
        self.EF.emittTime = 0
        self.EF.motorEmitting = false
        self.EF.motorStartPlayed = false
    end
end

function Pyskash:onTurnedOn()
    if self:getIsActive() then
        self.EF.emittTime = 0
        self.EF.threshingEmitting = true
        self.EF.motorEmitting = false
    end
end

function Pyskash:onTurnedOff()
    if self:getIsActive() then
        self.EF.threshingEmitting = false
    end
end

function Pyskash:draw()
end